unit PreCompiler;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, strutils, calc_utils, math;

const
  wtLetterWord  = 0;                         
  wtNumberValue = 1;
  wtHubridValue = -1;
  wtSumbolWord  = 2;
  wtString1     = 3;                            
  wtString2     = 4;                             
  wtCompilDirect= 5;                                                          
  wtWordsGroup  = 6;
  wtLambda      = 7;


  PascalWords = ' result and array of true read write false begin case const div do downto else end file for forward ' +
                  'function goto if in label mod nil not of or packed procedure ' +
                  'program class record var repeat set then to type until while with '+
                  'unit interface uses type record implementation operator initialization inline '+
                  'case do else for if switch virtual while struct then of parallel finalization ' +
                  'from to in if then for do while with overload override and or xor not '+
                  'except finally try constructor shl shr ' +
                  'inherited destructor destroy create :  ';
type


  TSourceWord = record
    source: ansistring;
    line: integer;
    char: integer;
    wordtype: Byte;
    childs: Array of TSourceWord;
  end;

  TOperatorWord = record
    OperatorWord: ansistring;
    OperatorFunction: ansistring;
  end;
  TOperatorWords = array of TOperatorWord;

  PSourceWord = ^TSourceWord;


  TSourceWords = Array of TSourceWord;


  function RemoveComments(ASource: AnsiString): AnsiString;
  function SourceWords(ASource: AnsiString): TSourceWords;
  function GroupWords(AWords: TSourceWords): TSourceWords;
  function Group(var AWords: TSourceWords; AFrom, ATo: integer):PSourceWord;

  function inOperators(ASource: ansistring):boolean;

  procedure OperatorsToFunctions(var AWords: TSourceWords; AOperatorWord: TOperatorWord);

  procedure addOperator(AOperatorWord: AnsiString; AFunction: AnsiString);
  function textFromWords(AOreginal: TStrings; const AWords: TSourceWords): ansistring;

  var
    OperatorWords: TOperatorWords;

implementation

var
  ChangedLines: Array of Boolean;


function RemoveComments(ASource: AnsiString): AnsiString;
var
  iCh: integer;
  iChar: Char;
  isString: Boolean;
  isDirective: Boolean;
  iLength: integer;
  iComment: integer;                                                                                                                                        
begin
  iLength:= Length(ASource);
  SetLength(Result,iLength);
  iComment:=0;
  for iCh := 1 to iLength do
  begin
    iChar:=ASource[iCh];
    Result[iCh] := ' ';

                                                                                                                              

    if iChar = #10 then
    begin
      Result[iCh] := #10;
      isString:=false;
    end;
    if iChar = #13 then
    begin
      Result[iCh] := #13;
      isString:=false;
    end;

    if (iComment = 0) and (not isString) then
      case iChar of
        '/': if (iCh < iLength) and (ASource[iCh+1] = '/') then iComment:=1;
        '{':
          begin
            if not ((iCh < iLength) and (ASource[iCh+1] = '$')) then iComment := 2;
            if ((iCh < iLength) and (ASource[iCh+1] = '$')) then isDirective:= true;
          end;
        '(': if (iCh < iLength) and (ASource[iCh+1] = '*') then iComment:=3;
      end;
    if (iComment = 2) and (not isString) and ((iCh < iLength)
        and (ASource[iCh] = '{') and (ASource[iCh+1] = '$')) then isDirective:= true;



    case iChar of
        '''': isString := not isString;
                                                                    
    end;
    if iComment <= 0 then Result[ich] := iChar;                                                                                 



    case iComment of
      1: case iChar of
                                                                                                                                          
           #10: iComment:=0;
           #13: iComment:=0;
         end;
      2: if (iChar = '}') and (not isString) then
         begin
           if isDirective then isDirective := false else iComment:=0;
         end;
      3: if ((ASource[iCh-1] = '*') and (iChar = ')')) and (not isString) then iComment:=0;
    end;
    if (iChar = '}') and isDirective then isDirective:=false;
  end;

end;

function SourceWords(ASource: AnsiString): TSourceWords;
var
  i: integer;
  iWord: integer;
  sChar: Char;
  sWord: AnsiString;
  iWordLine: Integer;
  iWordChar: Integer;
  iLine: integer;
  iChar: integer;
  iResult:  TSourceWords;
  iWordType: byte;                         
                                                         
                                                        
                                              
                                               
                                                                            

  procedure incWord(atype: byte = 0; AAddChar: boolean=false);
  begin

    if AAddChar then
      begin
        sWord+=sChar;
        sChar:=' ';

      end;

    if sWord <> '' then
      begin
        iResult[iWord].wordtype := iWordType;
        if iWordType < 3 then sWord:=AnsiLowerCase(sWord);
        iResult[iWord].source := sWord;
        iResult[iWord].line := iWordLine;
        iResult[iWord].char := iWordChar;
        if iResult[iWord].source = '.' then iResult[iWord].wordtype:=wtSumbolWord;
        Inc(iWord);
        sWord:='';
      end;
    iWordType:=atype;
    iWordLine:= iLine;
    iWordChar:= iChar;
  end;

begin
  iWord:=0;
  iLine:=1;
  iChar:=1;
  iWordLine:= 1;
  iWordChar:= 1;
  iWordType:=0;
  sWord:='';
  SetLength(iResult,Length(ASource));
  i := 0;
  while i < Length(ASource) do
  begin
    inc(i);
    sChar := ASource[i];
    inc(iChar);
    if sChar = #10 then
      begin
       inc(iLine);
       iChar:=1;
       incWord;
      end;
    case sChar of
      '#','$','%','&':
        if iWordType < 3 then
          if iWordType <> 1 then incWord(1);
      ';',':','+','*',',','~','!','(',')','|','\','/','?','-','=','`','<','>':
        if iWordType < 3 then
        begin
          case sChar of
            '(',')': incWord(2);
          end;
          if iWordType <> 2 then incWord(2);
          case sChar of
            '(',')': incWord(2,True);
          end;
        end;
      '''':
         if iWordType < 3 then incWord(3) else if iWordType = 3 then incWord(0,true);
      '"':
         if iWordType < 3 then incWord(4) else if iWordType = 4 then incWord(0,true);
      '{':
         if iWordType < 3 then incWord(5);
      '}':
         if iWordType = 5 then incWord(0,true);
      #0 .. #32:
        if iWordType < 3 then incWord;
      else
        if iWordType = 2 then incWord;
    end;
    if iWordType >= 3 then sWord+=sChar
    else
      case sChar of
        #0 .. #32:
          ;
        else
          sWord+=sChar;
    end;

  end;
  if sWord <> '' then incWord;

  SetLength(iResult,iWord);
  Result := iResult;
  SetLength(ChangedLines,iLine+1);
  for i := 0 to iLine do ChangedLines[i] := False;
end;

procedure FindVars(var AWords: TSourceWords);
var
  iAfterImplementation: Boolean;
  Iimplementation: PSourceWord;
  IImplBefore: boolean;
  iNewMethod: boolean;
  IVarHeads: array [0..255] of PSourceWord;
  IVarHeadCandidat: array [0..255] of Integer;
  ibuf: PSourceWord;
  IVarHead: integer;
  iBEBlockVars: array [0..255] of integer;
  iBEBlockCandidat: array [0..255] of integer;
  icandidat : Integer;
  iBEBlock: integer;
  CN:Boolean;
  s: ansistring;
  c:AnsiChar;

  procedure IFindVars(var AGroupWords: TSourceWords; AGroupLayer: integer);
  var
    i: integer;
  begin
    for i := 0 to Length(AGroupWords)-1 do
    begin
      if AGroupWords[i].source = 'interface' then iAfterImplementation:=false;

      if (i < Length(AGroupWords)-1) then
      if (AnsiPos(' '+AGroupWords[i+1].source+' ',PascalWords) < 1) then
      if (Length(AGroupWords[i].source) > 0) then
      if (Length(AGroupWords[i+1].source) > 0) then
      if (CharFilter(AGroupWords[i].source[1],'0123456789') <> '') then
      if (CharFilter(AGroupWords[i].source,'0123456789.') = AGroupWords[i].source) and (CharFilter(AGroupWords[i+1].source,'0123456789qwertyuiopasdfghjklzxcvbnm') = AGroupWords[i+1].source) then
      begin
        AGroupWords[i].wordtype:=wtNumberValue;
        AGroupWords[i+1].source:='*'+AGroupWords[i+1].source;
        AGroupWords[i+1].wordtype:=wtSumbolWord;
        ChangedLines[AGroupWords[i].line]:= True;
        ChangedLines[AGroupWords[i+1].line]:= True;
      end;


      if (Length(AGroupWords[i].source) > 0) then
      if (CharFilter(AGroupWords[i].source[1],'0123456789') <> '') then
      if (CharFilter(AGroupWords[i].source,'0123456789.,[]') <> AGroupWords[i].source) then
      if (CharFilter(AGroupWords[i].source,'0123456789qwertyuiopasdfghjklzxcvbnm') = AGroupWords[i].source) then
      begin
        CN := false;
        s := '(';
        for c in AGroupWords[i].source do
        begin
          if not CN and (CharFilter(c,'0123456789.,') = '') then
          begin
            s+='*';
            CN := true;
          end;
          s += c;
        end;
        s+=')';
        ChangedLines[AGroupWords[i].line] := true;
        AGroupWords[i].source := s;
      end;



      case AGroupWords[i].source of
        'uses','program', 'unit': IImplBefore := true;
        ';': if (iBEBlock < 1) and IImplBefore then
             begin
               IImplBefore:=false;
               Iimplementation:=@AGroupWords[i];
             end;
      end;
      if (AGroupWords[i].source ='implementation') and (AGroupLayer = 0) then
      begin
        Iimplementation:=@AGroupWords[i];
        iAfterImplementation:=true;
        IVarHead:=0;
        iBEBlock:=0;
        iBEBlockVars[0]:=0;
        IVarHeadCandidat[0]:=0;
        icandidat:=0;
        IVarHeads[IVarHead] := @AGroupWords[i];
      end;

      if iAfterImplementation and (AGroupLayer = 0) then
        case AGroupWords[i].source of
          'function','procedure','operator':
            iNewMethod:=true;
          ';':
            if iNewMethod then
            begin
              iNewMethod:=false;
              inc(IVarHead);
              IVarHeads[IVarHead] := @AGroupWords[i];
              icandidat+=1;
              iBEBlockCandidat[icandidat] := iBEBlock;
              IVarHeadCandidat[icandidat] := IVarHead;
            end;
          'case','begin':
            begin
              if iBEBlock = 0 then
              begin
                IVarHead:=IVarHeadCandidat[icandidat];
                icandidat :=max(0,icandidat-1);
              end;
              iBEBlock+=1;
              iBEBlockVars[iBEBlock] := IVarHead;
            end;
          'end':
            begin
              iBEBlock := max(0,iBEBlock-1);
              if iBEBlock = 0 then
                IVarHead:=IVarHeadCandidat[icandidat];
            end;
        end;
      if iAfterImplementation and (i < Length(AGroupWords)-1) and (AGroupWords[i].wordtype = wtLetterWord) and (AGroupWords[i+1].wordtype = wtLetterWord) then
        if (AnsiPos('.',AGroupWords[i].source) < 1) and (AnsiPos('.',AGroupWords[i+1].source) < 1) then
          if (AnsiPos(' '+AGroupWords[i].source+' ',PascalWords) < 1) and (AnsiPos(' '+AGroupWords[i+1].source+' ',PascalWords) < 1) then
          if (not inOperators(AGroupWords[i].source)) and (not inOperators(AGroupWords[i+1].source)) then
          begin
            if (IVarHead > 0) and (iBEBlock > 0) then ibuf := IVarHeads[iBEBlockVars[iBEBlock]]
              else ibuf := @AGroupWords[0];
            ChangedLines[ibuf^.line] := true;
            ChangedLines[AGroupWords[i+1].line] := true;
            ChangedLines[AGroupWords[i].line] := true;

            ibuf^.source += ' var '+ AGroupWords[i+1].source+': '+ AGroupWords[i].source + '; ';
            AGroupWords[i].source:='';
          end;
      if AGroupWords[i].wordtype=wtWordsGroup then
      begin
        IFindVars(AGroupWords[i].childs,AGroupLayer+1);
        if iAfterImplementation and (AGroupWords[i].source = '@') then
        begin
          ChangedLines[Iimplementation^.line] := true;
          ChangedLines[AGroupWords[i].line] := true;
          SetLength(Iimplementation^.childs,Length(Iimplementation^.childs)+1);
          Iimplementation^.childs[Length(Iimplementation^.childs)-1].source:='lambda_'+IntToStr(AGroupWords[i].line)+'_'+IntToStr(AGroupWords[i].char);
          Iimplementation^.childs[Length(Iimplementation^.childs)-1].childs := AGroupWords[i].childs;
          Iimplementation^.childs[Length(Iimplementation^.childs)-1].wordtype := wtLambda;
          AGroupWords[i].source:='@'+Iimplementation^.childs[Length(Iimplementation^.childs)-1].source;
          SetLength(AGroupWords[i].childs,0);
          AGroupWords[i].wordtype:=wtLetterWord;

        end;
      end;
    end;
  end;
begin
  IVarHeadCandidat[0] := 0;
  iBEBlock:=0;
  Iimplementation:=@AWords[0];
  IImplBefore := false;
  IVarHead := 0;
  icandidat:=0;
  iNewMethod := False;
  iAfterImplementation := true;
  IFindVars(AWords, 0);

end;

function GroupWords(AWords: TSourceWords): TSourceWords;
var
  i: integer;
  iBaseWord: TSourceWord;
  iAfterImplementation: Boolean;
  procedure IGroup(var AGroupWord: TSourceWord);
  var
    icurWord: TSourceWord;
    ichangeAllLines: boolean;
    iPyStart: TSourceWord;
    IPy: Boolean;
    iPyEnds: array of integer;
  begin
    inc(i);
    IPy := false;
    while (i < Length(AWords)) and (AWords[i].source <> ')') do
    begin
      ichangeAllLines:=false;
      SetLength(AGroupWord.childs,Length(AGroupWord.childs)+1);
      icurWord := AWords[i];

      while (Length(iPyEnds) > 0) and (iPyEnds[Length(iPyEnds)-1] >= icurWord.char) do
      begin
        AGroupWord.childs[Length(AGroupWord.childs)-1].wordtype:=wtSumbolWord;
        AGroupWord.childs[Length(AGroupWord.childs)-1].line:=AWords[i-1].line;
        AGroupWord.childs[Length(AGroupWord.childs)-1].char:=AWords[i-1].char;
        AGroupWord.childs[Length(AGroupWord.childs)-1].source:=' end;';
        SetLength(iPyEnds,Length(iPyEnds)-1);
        SetLength(AGroupWord.childs,Length(AGroupWord.childs)+1);
        ChangedLines[AWords[i-1].line] := true;
      end;

      case icurWord.source of
        'if','with','while','for':
          begin
            IPy:=true;
            iPyStart:=icurWord;
          end;
        ';','do','then':
            IPy:=False;
        'else':
            if (Length(AGroupWord.childs) > 1) and (AGroupWord.childs[Length(AGroupWord.childs)-2].source = ' end;') then
              AGroupWord.childs[Length(AGroupWord.childs)-2].source := ' end ';
        ':':
          if (IPy) or ((i > 0) and (AWords[i-1].source = 'else')) then begin
            IPy:=False;
            SetLength(iPyEnds,Length(iPyEnds)+1);
            iPyEnds[Length(iPyEnds)-1] := iPyStart.char;
            icurWord.source:=' begin ';
            icurWord.wordtype:=wtSumbolWord;

            AGroupWord.childs[Length(AGroupWord.childs)-1].wordtype:=wtSumbolWord;
            AGroupWord.childs[Length(AGroupWord.childs)-1].line:=icurWord.line;
            AGroupWord.childs[Length(AGroupWord.childs)-1].char:=icurWord.char;
            if AWords[i-1].source <> 'else' then
            begin
              if iPyStart.source = 'if' then AGroupWord.childs[Length(AGroupWord.childs)-1].source:=' then '
                else AGroupWord.childs[Length(AGroupWord.childs)-1].source:=' do ';
            end;
            SetLength(AGroupWord.childs,Length(AGroupWord.childs)+1);
            ChangedLines[icurWord.line] := true;
          end;
      end;

      if icurWord.source = 'interface' then iAfterImplementation:=false;
      if icurWord.source = 'implementation' then iAfterImplementation:=true;
      if icurWord.source = '(' then
      begin
         icurWord.source:= '';
         if (Length(AGroupWord.childs) > 1) and (
         (AGroupWord.childs[Length(AGroupWord.childs)-2].wordtype = wtLetterWord)
         or (AGroupWord.childs[Length(AGroupWord.childs)-2].source = ';')
         or (AGroupWord.childs[Length(AGroupWord.childs)-2].source = ':')
           ) then
         begin
            SetLength(AGroupWord.childs,Length(AGroupWord.childs)-1);
            icurWord := AGroupWord.childs[Length(AGroupWord.childs)-1];
            case icurWord.source of
              'then','do','else',';',':': ichangeAllLines:=True;
            end;
         end;
         if ichangeAllLines then ChangedLines[icurWord.line] := true;
         if ichangeAllLines then ChangedLines[AWords[i].line] := true;
         IGroup(icurWord);
         if ichangeAllLines then ChangedLines[AWords[i].line] := true;
         icurWord.wordtype:=wtWordsGroup;
      end;
      AGroupWord.childs[Length(AGroupWord.childs)-1] := icurWord;
      Inc(i);
    end;
  end;
begin
  iAfterImplementation:=true;
  i := -1;
  SetLength(iBaseWord.childs,1);
  iBaseWord.childs[0].line:=1;
  iBaseWord.childs[0].char:=1;
  iBaseWord.childs[0].wordtype:=wtCompilDirect;
  iBaseWord.childs[0].source:='{precompiled}';
  ChangedLines[0] := True;
  IGroup(iBaseWord);
  Result := iBaseWord.childs;
  FindVars(Result);
  for i := 0 to Length(OperatorWords)-1 do
    OperatorsToFunctions(Result,OperatorWords[i]);

end;

function Group(var AWords: TSourceWords; AFrom, ATo: integer): PSourceWord;
var
  buf: array of TSourceWord;
  i:integer;
begin

    
  SetLength(buf, ATo-AFrom+1);
  for i := 0 to ATo-AFrom do
  begin
    buf[i] := AWords[i+AFrom];
    ChangedLines[AWords[i+AFrom].line] := true;
  end;

  for i := 1 to Length(AWords)-ATo-1 do
  begin
    AWords[i+AFrom] := AWords[i+ATo];
  end;
  SetLength(AWords,Length(AWords)-(ATo-AFrom));

  AWords[AFrom].wordtype:= wtWordsGroup;
  AWords[AFrom].childs := buf;
  AWords[AFrom].source := '';
  Result := @AWords[AFrom];

end;

function inOperators(ASource: ansistring): boolean;
var
  i:integer;
begin
  Result := false;
  for i := 0 to Length(OperatorWords)-1 do
    if OperatorWords[i].OperatorWord = ASource then Result := true;

end;

procedure OperatorsToFunctions(var AWords: TSourceWords; AOperatorWord: TOperatorWord);
var
  i : integer;
  ifrom : integer;
  ito : integer;
  function isStopChar(AChar: ansistring):boolean;
  begin
    case AChar of
      ';',',',':=','+=','-=','/=','*=','**=','from','to', 'in','if','then','for','do','while','with','and','or','xor','not': Result := true;
      else Result := false;
    end;
  end;

  function indexOfOperator(AChar: ansistring):integer;
  var
    ib: integer;
  begin
    Result := -1;
    for ib := 0 to Length(OperatorWords)-1 do
      if OperatorWords[ib].OperatorWord = AChar then Result := ib;
  end;

begin

  i := 0;
  while i < Length(AWords) do
  begin
    if AWords[i].source = AOperatorWord.OperatorWord then
    begin
      AWords[i].source := ',';
      ifrom:=i-1;
      while (ifrom > -1) and not isStopChar(AWords[ifrom].source) do ifrom -= 1;
      ifrom += 1;
      ito:=i+1;
      while (ito < Length(AWords)) and not isStopChar(AWords[ito].source) do ito += 1;
      ito -= 1;
      Group(AWords,ifrom,ito)^.source:=AOperatorWord.OperatorFunction;
      i := ifrom;
    end;
    if AWords[i].wordtype = wtWordsGroup then OperatorsToFunctions(AWords[i].childs, AOperatorWord);
    inc(i)
  end;


end;

procedure addOperator(AOperatorWord: AnsiString; AFunction: AnsiString);
begin
    
  SetLength(OperatorWords,Length(OperatorWords)+1);
  OperatorWords[Length(OperatorWords)-1].OperatorFunction:=AFunction;
  OperatorWords[Length(OperatorWords)-1].OperatorWord:=AOperatorWord;
end;


function textFromWords(AOreginal: TStrings; const AWords: TSourceWords): ansistring;
var
  i, i2: integer;
  iResult: array of AnsiString;
  procedure writeword(const AWord: TSourceWord; APos: boolean);
  var
    i3:integer;
    p:pointer;
    CN: boolean;
    c: AnsiChar;
    s: ansistring;
  begin

    if ((AWord.wordtype = wtLetterWord) or ((AWord.wordtype = wtWordsGroup) and (AWord.source <> '') )) then iResult[i] +=' ';
    if AWord.wordtype = wtLambda then iResult[i] += ' procedure ';
    iResult[i] += AWord.source;
    if AWord.wordtype = wtLambda then iResult[i] += '(A: TParams = nil); begin ';
//    if AWord.wordtype = wtWordsGroup then
  //  begin
      if AWord.wordtype = wtWordsGroup then
        case AWord.source of
          'then','do','else',';',':': iResult[i] += ' begin ';
        else
          iResult[i] += '(';
        end;
      for i3 := 0 to Length(AWord.childs)-1 do
      begin
        if APos and (AWord.wordtype <> wtLambda) and (AWord.wordtype <> wtString1) then
        begin
          while i < AWord.childs[i3].line do i += 1;
          while Length(iResult[i]) < AWord.childs[i3].char-2 do iResult[i]+=' ';
        end;
        writeword(AWord.childs[i3], (AWord.wordtype <> wtLambda) and APos);
      end;
      if AWord.wordtype = wtLambda then
        iResult[i] += ' end;';
      if AWord.wordtype = wtWordsGroup then
        case AWord.source of
          'then','do','else',';',':': iResult[i] += ' end ';
        else
          iResult[i] += ')';
        end;
//    end;
  end;

begin
  Result := '';
  SetLength(iResult,Length(ChangedLines));
  i := 1;
  while i < Length(ChangedLines)-1 do
  begin
    if not ChangedLines[i] then
      iResult[i] += AOreginal[i-1]
      else
          for  i2 := 0 to Length(AWords)-1 do
            if AWords[i2].line = i then
              writeword(AWords[i2], true);


    i += 1;
  end;

  for i := 1 to Length(iResult)-1 do
    Result += iResult[i]+#13#10;
end;

initialization

  addOperator('|>','DBLarge');
  addOperator('<|','DBLower');

end.


