unit calc_utils;
Interface

{$MODE objfpc}
{$H+}

uses dos, sysutils, strutils, Classes,  math, FileUtil, Masks, zstream, base64, process, variants;



const
  nochars:array [0..3] of ansistring = (' ', #10, #13, #14);
  nocharsto:array [0..3] of ansistring = ('', '', '', '');
  Prigolosni:array [0..41] of ansistring = ('й', 'Й', 'ц', 'Ц', 'к' ,'К','н','Н','г','Г','ш','Ш','щ','Щ','з','З','х','Х','ф','Ф','в','В','п','П','р','Р','л','Л','д','Д','ж','Ж','ч','Ч','с','С','м','М','т','Т','б','Б');
  glasn:array [0..23] of ansistring = ('у','У','е','Е','ї','Ї','ы','Ы','і','І','а','А','о','О','є','Є','э','Э','я','Я','и','И','ю','Ю');
  PrigolosniLat:ansistring = 'qQwWrRtTyYpPsSdDfFgGhHjJkKlLzZxXcCvVbBnNmM';
  glasnLat:ansistring = 'eEuUiIoOaAyY';


const
  MyDayNames: array[1..7] of AnsiString =
    ('Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat');
var
  MyMonthNames: array[0..6, 1..12] of ansistring =
    (
    ('Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun',  //rewrited by system locales
     'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'),
    ('Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun',  //English
     'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'),
    ('jan', 'fév', 'mar', 'avr', 'mai', 'jun', //French
     'jul', 'aoû', 'sep', 'oct', 'nov', 'déc'),
    ('jan', 'fev', 'mar', 'avr', 'mai', 'jun',  //French#2
     'jul', 'aou', 'sep', 'oct', 'nov', 'dec'),
    ('Jan', 'Feb', 'Mar', 'Apr', 'Mai', 'Jun',  //German
     'Jul', 'Aug', 'Sep', 'Okt', 'Nov', 'Dez'),
    ('Jan', 'Feb', 'Mär', 'Apr', 'Mai', 'Jun',  //German#2
     'Jul', 'Aug', 'Sep', 'Okt', 'Nov', 'Dez'),
    ('Led', 'Úno', 'Bøe', 'Dub', 'Kvì', 'Èen',  //Czech
     'Èec', 'Srp', 'Záø', 'Øíj', 'Lis', 'Pro')
     );




type

  TParams = Array of variant;

  int = int64;
  str = String;
  bool = boolean;
  float = double;

  TArrayOfString = array of String;


  TFileAttr = (ftReadOnly, ftHidden, ftSystem, ftVolumeID, ftDirectory,
               ftArchive, ftNormal);
  TFileType = set of TFileAttr;


  TDoubleArray = array [0..1000000] of double;
  PDoubleArray = ^TDoubleArray;

  TSingleArray = array [0..1000000] of Single;
  PSingleArray = ^TSingleArray;

  TArrayOfInteger = array of integer;

  TArrayOfAnsistring = array of AnsiString;


  TNameValueItem =
  record
    name : AnsiString;
    value : AnsiString;
  end;

  TNameValueArray = array of TNameValueItem;

  { TFileMemoryStream }

  TFileMemoryStream = class(TMemoryStream)
  private
    FFileName: ansistring;
    FFileAge: Int64;
    procedure SetFileName(AValue: ansistring);
    public
      procedure reload;
      property FileName: ansistring read FFileName write SetFileName;
  end;

  { TCValueList }

  TCValueList = class(TPersistent)
  private
    function GetValue(const AName: ansistring): ansistring;
    procedure SetValue(const AName: ansistring; const AValue: ansistring);
  public
    Ffilename: ansistring;
    fnames, fvalues: array of ansistring;
    constructor create;
    destructor destroy; override;
    property Values[const Name: ansistring]: ansistring read GetValue write SetValue; default;
    function NameOfValue(AValue: ansistring):ansistring;
    function count:integer;
    procedure DeleteAllOfValue(AValue: ansistring);
    procedure LoadFromFile(AFileName: ansistring);
    procedure SaveToFile(AFileName: ansistring);
    procedure Save; virtual;
    procedure add(AName: Ansistring; AValue: ansistring);
    procedure add(AStringINI: ansistring); overload;
    procedure Assign(Source: TPersistent); override;
  end;





TArrayOfByte=array of byte;



//&shy;.


type
  TCVType = (CVTfloat, CVTstring);

  TAnsiStringArray = array of AnsiString;

  TCalc_TPL_VAR =
  record
    name : ansistring;
    value : ansistring;
  end;

  TArrayOfCalcTplVars = array of Variant;




  function CharFilter(ASource:ansistring; AFilter:ansistring = '1234567890qwertyuiopasdfghjklzxcvbnmQWERTYUIOPASDFGHJKLZXCVBNM_-'):ansistring;

  function HTMLChars(ASource:ansistring):ansistring;





  function insertshy(ASource:ansistring):ansistring;



  function SplitStringToLangs(ALangString: AnsiString):TNameValueArray;
  function SetLangString(ANewValue:ansistring; ALang:ansistring; ADefLang:ansistring; ALangString:ansistring): ansistring;
  function GetLangString(ALangString:ansistring; ALang:ansistring; ADefLang:ansistring = ''): ansistring;



  operator in (AInput1: ansistring; AInput2:array of ansistring):boolean;


  function split(ASource, ASpliter: ansistring; var AOut1, AOut2: ansistring): boolean;
  function DataTimeToCookieDataTime(ADataTime:TDateTime):ansistring;
  function ResampleByIni(ASource:ansistring; AINIFile:ansistring; ARevers:Boolean = false):ansistring;

  function tplvar(AName, AValue:ansistring): TCalc_TPL_VAR;

  function LangthLimit(ASource: ansistring; ALimitSize: integer; ALimiter: ansistring = '...'):ansistring;

  function QuotesEnc(ASource:ansistring):ansistring;
  function QuotesDec(ASource:ansistring):ansistring;
  function RemoveHTMLTegs(ASource: ansistring):ansistring;
  function HTMLToText(ASource: ansistring):ansistring;
  function GetIndexFromString(ASource: ansistring):ansistring;

  function GzBase64(const s: ansistring): ansistring;
  function GzCompress(const s: ansistring): ansistring;
  var OutStream, InpStream, GzStream, b64Stream: TStream;

  function AnsiPosEx(ASubStr: ansistring; ASource: ansistring; AOffset: integer=0):integer;
  function lowcase(ASource: ansistring):ansistring;
  function uprcase(ASource: ansistring):ansistring;

  function GetFileList(ARoot_path:ansistring; ASubPath: ansistring; AFilter: ansistring; AFileType: TFileType): tstringlist;
  function GetException(ExceptObject: TObject; ExceptAddr: Pointer):ansistring;

  function wordsFromHtml(ASource:ansistring):TArrayOfAnsistring;
  function wordsFromText(ASource:ansistring):TArrayOfAnsistring;

  function Cp_1251ToUtf8(const s:ansistring):ansistring;

  function StringSum(ASource:ansistring):integer;
  function WordsSumm(ASource:TArrayOfAnsistring):integer;

  function ArrayToAnsiString(AInput: TAnsiStringArray): ansistring;

  function cMemoryStreamFromFile(AFileName: AnsiString): TFileMemoryStream;
  function Split(const aSeparator, aString: String; aMax: Integer = 0): TArrayOfString;  overload;

  procedure tryfree(AObject: TObject);

  function join(const AIn1: ansistring;const AIn2: ansistring):ansistring;inline;

  operator := (r: Int64): AnsiString;
  operator := (r: Double): AnsiString;
  operator := (r: boolean): AnsiString;


Implementation


operator:=(r: Int64): AnsiString;
begin
  result := IntToStr(r);
end;

operator:=(r: Double): AnsiString;
begin
result := FloatToStr(r);

end;

operator:=(r: boolean): AnsiString;
begin
  if r then result := '1' else result := '0';
end;




operator in(AInput1: ansistring; AInput2: array of ansistring): boolean;
var
   i:integer;
begin
  for i:= 0 to Length(AInput2)-1 do
    if AInput2[i] = AInput1 then
    begin
      result := true;
      exit;
    end;
  result := false;
end;



function Split(const aSeparator, aString: String; aMax: Integer = 0): TArrayOfString;
var
  i, strt, cnt: Integer;
  sepLen: Integer;

  procedure AddString(aEnd: Integer = -1);
  var
    endPos: Integer;
  begin
    if (aEnd = -1) then
      endPos := i
    else
      endPos := aEnd + 1;

    if (strt < endPos) then
      result[cnt] := Copy(aString, strt, endPos - strt)
    else
      result[cnt] := '';

    Inc(cnt);
  end;

begin
  if (aString = '') or (aMax < 0) then
  begin
    SetLength(result, 0);
    EXIT;
  end;

  if (aSeparator = '') then
  begin
    SetLength(result, 1);
    result[0] := aString;
    EXIT;
  end;

  sepLen := Length(aSeparator);
  SetLength(result, (Length(aString) div sepLen) + 1);

  i     := 1;
  strt  := i;
  cnt   := 0;
  while (i <= (Length(aString)- sepLen + 1)) do
  begin
    if (aString[i] = aSeparator[1]) then
      if (Copy(aString, i, sepLen) = aSeparator) then
      begin
        AddString;

        if (cnt = aMax) then
        begin
          SetLength(result, cnt);
          EXIT;
        end;

        Inc(i, sepLen - 1);
        strt := i + 1;
      end;

    Inc(i);
  end;

  AddString(Length(aString));

  SetLength(result, cnt);
end;

function Cp_1251ToUtf8(const s:ansistring):ansistring;
var i,n,j, Len:integer;
begin
SetLength(Result,Length(s)*3);
j:=1;
For i:=1 to Length(s) do begin
  n:=ord(s[i]);
  Case n of //One byte and russion symbols
  1..127:
    begin
      Result[j]:=s[i];
      Inc(j);
    end;
  128: begin Result[j]:=#208;  Inc(j); Result[j]:=#130;  Inc(j);  end; //€
  129: begin Result[j]:=#208;  Inc(j); Result[j]:=#131;  Inc(j);  end; //
  130: begin Result[j]:=#226;  Inc(j); Result[j]:=#128;  Inc(j); Result[j]:=#154;  Inc(j);  end; //‚
  131: begin Result[j]:=#209;  Inc(j); Result[j]:=#147;  Inc(j);  end; //ƒ
  132: begin Result[j]:=#226;  Inc(j); Result[j]:=#128;  Inc(j); Result[j]:=#158;  Inc(j);  end; //„
  133: begin Result[j]:=#226;  Inc(j); Result[j]:=#128;  Inc(j); Result[j]:=#166;  Inc(j);  end; //…
  134: begin Result[j]:=#226;  Inc(j); Result[j]:=#128;  Inc(j); Result[j]:=#160;  Inc(j);  end; //†
  135: begin Result[j]:=#226;  Inc(j); Result[j]:=#128;  Inc(j); Result[j]:=#161;  Inc(j);  end; //‡
  136: begin Result[j]:=#226;  Inc(j); Result[j]:=#130;  Inc(j); Result[j]:=#172;  Inc(j);  end; //ˆ
  137: begin Result[j]:=#226;  Inc(j); Result[j]:=#128;  Inc(j); Result[j]:=#176;  Inc(j);  end; //‰
  138: begin Result[j]:=#208;  Inc(j); Result[j]:=#137;  Inc(j);  end; //Š
  139: begin Result[j]:=#226;  Inc(j); Result[j]:=#128;  Inc(j); Result[j]:=#185;  Inc(j);  end; //‹
  140: begin Result[j]:=#208;  Inc(j); Result[j]:=#138;  Inc(j);  end; //Œ
  141: begin Result[j]:=#208;  Inc(j); Result[j]:=#140;  Inc(j);  end; //
  142: begin Result[j]:=#208;  Inc(j); Result[j]:=#139;  Inc(j);  end; //Ž
  143: begin Result[j]:=#208;  Inc(j); Result[j]:=#143;  Inc(j);  end; //
  144: begin Result[j]:=#209;  Inc(j); Result[j]:=#146;  Inc(j);  end; //
  145: begin Result[j]:=#226;  Inc(j); Result[j]:=#128;  Inc(j); Result[j]:=#152;  Inc(j);  end; //‘
  146: begin Result[j]:=#226;  Inc(j); Result[j]:=#128;  Inc(j); Result[j]:=#153;  Inc(j);  end; //’
  147: begin Result[j]:=#226;  Inc(j); Result[j]:=#128;  Inc(j); Result[j]:=#156;  Inc(j);  end; //“
  148: begin Result[j]:=#226;  Inc(j); Result[j]:=#128;  Inc(j); Result[j]:=#157;  Inc(j);  end; //”
  149: begin Result[j]:=#226;  Inc(j); Result[j]:=#128;  Inc(j); Result[j]:=#162;  Inc(j);  end; //•
  150: begin Result[j]:=#226;  Inc(j); Result[j]:=#128;  Inc(j); Result[j]:=#147;  Inc(j);  end; //–
  151: begin Result[j]:=#226;  Inc(j); Result[j]:=#128;  Inc(j); Result[j]:=#148;  Inc(j);  end; //—
  152: begin Result[j]:=#194;  Inc(j); Result[j]:=#152;  Inc(j);  end; //˜
  153: begin Result[j]:=#226;  Inc(j); Result[j]:=#132;  Inc(j); Result[j]:=#162;  Inc(j);  end; //™
  154: begin Result[j]:=#209;  Inc(j); Result[j]:=#153;  Inc(j);  end; //š
  155: begin Result[j]:=#226;  Inc(j); Result[j]:=#128;  Inc(j); Result[j]:=#186;  Inc(j);  end; //›
  156: begin Result[j]:=#209;  Inc(j); Result[j]:=#154;  Inc(j);  end; //œ
  157: begin Result[j]:=#209;  Inc(j); Result[j]:=#156;  Inc(j);  end; //
  158: begin Result[j]:=#209;  Inc(j); Result[j]:=#155;  Inc(j);  end; //ž
  159: begin Result[j]:=#209;  Inc(j); Result[j]:=#159;  Inc(j);  end; //Ÿ
  160: begin Result[j]:=#194;  Inc(j); Result[j]:=#160;  Inc(j);  end; //
  161: begin Result[j]:=#208;  Inc(j); Result[j]:=#142;  Inc(j);  end; //¡
  162: begin Result[j]:=#209;  Inc(j); Result[j]:=#158;  Inc(j);  end; //¢
  163: begin Result[j]:=#208;  Inc(j); Result[j]:=#136;  Inc(j);  end; //£
  164: begin Result[j]:=#194;  Inc(j); Result[j]:=#164;  Inc(j);  end; //¤
  165: begin Result[j]:=#210;  Inc(j); Result[j]:=#144;  Inc(j);  end; //¥
  166: begin Result[j]:=#194;  Inc(j); Result[j]:=#166;  Inc(j);  end; //¦
  167: begin Result[j]:=#194;  Inc(j); Result[j]:=#167;  Inc(j);  end; //§
  168: begin Result[j]:=#208;  Inc(j); Result[j]:=#129;  Inc(j);  end; //¨
  169: begin Result[j]:=#194;  Inc(j); Result[j]:=#169;  Inc(j);  end; //©
  170: begin Result[j]:=#208;  Inc(j); Result[j]:=#132;  Inc(j);  end; //ª
  171: begin Result[j]:=#194;  Inc(j); Result[j]:=#171;  Inc(j);  end; //«
  172: begin Result[j]:=#194;  Inc(j); Result[j]:=#172;  Inc(j);  end; //¬
  173: begin Result[j]:=#194;  Inc(j); Result[j]:=#173;  Inc(j);  end; //­
  174: begin Result[j]:=#194;  Inc(j); Result[j]:=#174;  Inc(j);  end; //®
  175: begin Result[j]:=#208;  Inc(j); Result[j]:=#135;  Inc(j);  end; //¯
  176: begin Result[j]:=#194;  Inc(j); Result[j]:=#176;  Inc(j);  end; //°
  177: begin Result[j]:=#194;  Inc(j); Result[j]:=#177;  Inc(j);  end; //±
  178: begin Result[j]:=#208;  Inc(j); Result[j]:=#134;  Inc(j);  end; //²
  179: begin Result[j]:=#209;  Inc(j); Result[j]:=#150;  Inc(j);  end; //³
  180: begin Result[j]:=#210;  Inc(j); Result[j]:=#145;  Inc(j);  end; //´
  181: begin Result[j]:=#194;  Inc(j); Result[j]:=#181;  Inc(j);  end; //µ
  182: begin Result[j]:=#194;  Inc(j); Result[j]:=#182;  Inc(j);  end; //¶
  183: begin Result[j]:=#194;  Inc(j); Result[j]:=#183;  Inc(j);  end; //·
  184: begin Result[j]:=#209;  Inc(j); Result[j]:=#145;  Inc(j);  end; //¸
  185: begin Result[j]:=#226;  Inc(j); Result[j]:=#132;  Inc(j); Result[j]:=#150;  Inc(j);  end; //¹
  186: begin Result[j]:=#209;  Inc(j); Result[j]:=#148;  Inc(j);  end; //º
  187: begin Result[j]:=#194;  Inc(j); Result[j]:=#187;  Inc(j);  end; //»
  188: begin Result[j]:=#209;  Inc(j); Result[j]:=#152;  Inc(j);  end; //¼
  189: begin Result[j]:=#208;  Inc(j); Result[j]:=#133;  Inc(j);  end; //½
  190: begin Result[j]:=#209;  Inc(j); Result[j]:=#149;  Inc(j);  end; //¾
  191: begin Result[j]:=#209;  Inc(j); Result[j]:=#151;  Inc(j);  end; //¿

  192..239://'À'..'ï'
    begin
      Result[j]:=#208;  Inc(j);
      Result[j]:=Char(n-48);  Inc(j);
    end;
  240..255://'ð'..'ÿ'
    begin
      Result[j]:=#209;  Inc(j);
      Result[j]:=Char(n-112);  Inc(j);
    end;
  end;//Case
end;

SetLength(Result,j-1);
end;

function StringSum(ASource: ansistring): integer;
var
i:integer;
begin
 Result :=0;

 for i := 1 to Length(ASource) do
   Result:=(Result+byte(ASource[i])) shl 1;

end;

function WordsSumm(ASource: TArrayOfAnsistring): integer;
var i:integer;
begin
Result:=0;
for i := 0 to Length(ASource)-1 do
  Result := Result xor StringSum(ASource[i]);

end;



function GzBase64(const s: ansistring): ansistring;
var OutStream, InpStream, GzStream, b64Stream: TStream;
begin
 OutStream := TStringStream.Create('');
 try
    b64Stream := TBase64EncodingStream.Create(OutStream);
    try
       GzStream := Tcompressionstream.create(clmax,b64Stream);
       try
          InpStream := TStringStream.Create(s);
          try
             // Copy input stream
             GzStream.CopyFrom(InpStream,InpStream.Size);

             // Flush compression and then base64
             Tcompressionstream(GzStream).flush;
             TBase64EncodingStream(b64Stream).flush;

             // Read out datastring :)
             result := TStringStream(OutStream).DataString;
          finally
             InpStream.Free;
          end;
       finally
          GzStream.Free;
       end;
    finally
       b64Stream.Free;
    end;
 finally
    OutStream.Free;
 end;
end;

function GzCompress(const s: ansistring): ansistring;
var OutStream, InpStream, GzStream, b64Stream: TStream;
begin
 OutStream := TStringStream.Create('');
 try
       GzStream := Tcompressionstream.create(clmax,OutStream);
       try
          InpStream := TStringStream.Create(s);
          try
             // Copy input stream
             GzStream.CopyFrom(InpStream,InpStream.Size);

             // Flush compression and then base64
             Tcompressionstream(GzStream).flush;

             // Read out datastring :)
             result := TStringStream(OutStream).DataString;
          finally
             InpStream.Free;
          end;
       finally
          GzStream.Free;
       end;
 finally
    OutStream.Free;
 end;
end;

function insertshy(ASource: ansistring): ansistring;
var
i:integer;
isTeg:boolean;
isSpecChar:boolean;
begin
//&shy;.
if Length(ASource) < 4 then
begin
  Result := ASource;
  exit;
end;
isSpecChar:=False;
isTeg:=False;
for i := 1 to Length(ASource)-3 do
begin
  case ASource[i] of
  '&': isSpecChar:=true;
  '<': isTeg:=true;
  end;

  if (i > 2)and(not isSpecChar)and(not isTeg) then
    if (ASource[i-1] <> ' ')and(ASource[i-1] <> ';')and(ASource[i-1] <> '>')and(ASource[i-1] <> '&') then
      if (ASource[i-2] <> ' ')and(ASource[i-2] <> ';')and(ASource[i-2] <> '>')and(ASource[i-2] <> '&') then
      begin

        if (Pos(ASource[i+1], glasnLat) > 0) and (pos(ASource[i], PrigolosniLat) > 0) then
            Result+='&shy;' else
            if i > 3 then
              if (ASource[i-3] <> ' ')and(ASource[i-3] <> ';')and(ASource[i-3] <> '>')and(ASource[i-3] <> '&') then
                if ASource[i+2]+ASource[i+3] in glasn then
                  if ASource[i]+ASource[i+1] in Prigolosni then
                    Result+='&shy;';
        if (Pos(ASource[i+1], glasnLat) > 0) and (pos(ASource[i], glasnLat) > 0) then
            Result+='&shy;' else
            if i > 5 then
                if ASource[i]+ASource[i+1] in glasn then
                    if ASource[i-2]+ASource[i-1] in glasn then
                        if ASource[i-4]+ASource[i-3] in glasn then
                    Result+='&shy;';
      end;
  Result+=ASource[i];
  case ASource[i] of
  ';': isSpecChar:=false;
  ' ': isSpecChar:=false;
  '>':
  begin
    isTeg:=false;
    isSpecChar:=false;
  end;
  end;
end;
Result+=ASource[i+1]+ASource[i+2]+ASource[i+3];
end;




function GetException(ExceptObject: TObject; ExceptAddr: Pointer):ansistring;

// use shortstring. On exception, the heap may be corrupt.

Var
Buf : ShortString;

begin
SetLength(Buf,ExceptionErrorMessage(ExceptObject,ExceptAddr,@Buf[1],255));
//  If IsConsole Then
//  writeln(Buf)
// else
//    If Assigned(OnShowException) Then
//    OnShowException (Buf);

Result := Buf;

end;

function wordsFromHtml(ASource: ansistring): TArrayOfAnsistring;
begin
Result := wordsFromText(HTMLToText(ASource));
end;

function wordsFromText(ASource: ansistring): TArrayOfAnsistring;
var
i,i2 :integer;
ic:ansistring;
b , b1:byte;
ischar:boolean;
procedure tadd;
begin
 if Result[i2] <> '' then
 begin
   Inc(i2);
   SetLength(Result,i2+1);
   Result[i2] := '';
 end;
end;

begin
ic:='';
i := 1;
i2 := 0;
ASource:=lowcase(ASource);
SetLength(Result,1);
Result[0]:='';

while i <= Length(ASource) do
begin
ischar := false;
b := byte(ASource[i]);
b1 := b;
if ((b >= 97) and (b <= 122))or((b >= 65) and (b <= 90)) then
begin
  Result[i2] += char(b);
  ischar:=true;

end else
if (b and %10000000) = %10000000 then
  if(b1 <> 226) and (b1 <> 194) then
  begin
    ic:= char(b);
    inc(i);
    while (i <= Length(ASource))and((byte(ASource[i]) and %11000000) = %10000000) do
    begin
      ic += ASource[i];
      inc(i);
    end;
    inc(i,-1);
    Result[i2] += ic;
    ic:='';
    ischar:=true;
  end;
if not ischar then tadd;
inc(i);
end;

if Result[Length(Result)-1] = '' then SetLength(Result,Length(Result)-1);


//    testStr.replaceAll("[^ a-zA-zА-Яа-яёЁ]+", " ");
{  i2:=0;
for i := 1 to Length(ASource) do
  begin
    case ASource[i] of
      ',',' ', #13, #14, #10, '-', '_', ';', '.','"','''', '(', ')',
      '[', ']', '<', '>', '|', '/', '\', '{', '}', '*', '!', '@', '#',
      '$', '%', '^', '&', '~', '`','=','?':tadd;
      else Result[i2] += ASource[i];
    end;

  end;
}
end;

     {
function TimeZoneBias: integer;
{$IFNDEF MSWINDOWS}
{$IFNDEF FPC}
var
t: TTime_T;
UT: TUnixTime;
begin
__time(@T);
localtime_r(@T, UT);
Result := ut.__tm_gmtoff div 60;
{$ELSE}
begin
Result := TZSeconds div 60;
{$ENDIF}
{$ELSE}
var
zoneinfo: TTimeZoneInformation;
bias: Integer;
begin
case GetTimeZoneInformation(Zoneinfo) of
  2:
    bias := zoneinfo.Bias + zoneinfo.DaylightBias;
  1:
    bias := zoneinfo.Bias + zoneinfo.StandardBias;
else
  bias := zoneinfo.Bias;
end;
Result := bias * (-1);
{$ENDIF}
end;


function TimeZone: ansistring;
var
bias: Integer;
h, m: Integer;
begin
bias := TimeZoneBias;
if bias >= 0 then
  Result := '+'
else
  Result := '-';
bias := Abs(bias);
h := bias div 60;
m := bias mod 60;
Result := Result + Format('%.2d%.2d', [h, m]);
end;

function Rfc822DateTime(t: TDateTime): ansistring;
var
wYear, wMonth, wDay: word;
begin
DecodeDate(t, wYear, wMonth, wDay);
Result := Format('%s, %d %s %s %s', [MyDayNames[DayOfWeek(t)], wDay,
  MyMonthNames[1, wMonth], FormatDateTime('yyyy hh":"nn":"ss', t), TimeZone]);
end;
      }

function QuotesEnc(ASource: ansistring): ansistring;
begin
ASource:=AnsiReplaceStr(ASource,'''','%apostrof%');
result:=AnsiReplaceStr(ASource,'"','%lapki%');
end;

function QuotesDec(ASource: ansistring): ansistring;
begin
ASource:=AnsiReplaceStr(ASource,'%apostrof%','''');
result:=AnsiReplaceStr(ASource,'%lapki%','"');

end;



function GetFileList(ARoot_path:ansistring; ASubPath: ansistring; AFilter: ansistring; AFileType: TFileType): tstringlist;
const
AttrNotNormal = faReadOnly or
                faHidden or
                faSysFile or
                faVolumeID or
                faDirectory or
                faArchive;
var
Info: TSearchRec;
IItems: TStringList;
apath: ansistring;

function FileTypeToFileAttribute(FileType: TFileType): LongInt;
const
  FileTypeToAttrMap: array[TFileAttr] of LongInt =
  (
{ ftReadOnly  } faReadOnly,
{ ftHidden    } faHidden,
{ ftSystem    } faSysFile,
{ ftVolumeID  } faVolumeId,
{ ftDirectory } faDirectory,
{ ftArchive   } faArchive,
{ ftNormal    } 0
  );
var
  Iter: TFileAttr;
begin
  Result := 0;
  for Iter := Low(TFileAttr) to High(TFileAttr) do
    if Iter in FileType then
      Result := Result or FileTypeToAttrMap[Iter];
end;

begin
IItems := TStringList.Create;

apath:=ARoot_path+ASubPath;

IItems.Clear;
if AFileType <> [] then
begin
  if FindFirstUTF8(
    IncludeTrailingPathDelimiter(APath)+AllDirectoryEntriesMask,
    FileTypeToFileAttribute(AFileType), Info) = 0
  then
    repeat
      if MatchesMaskList(Info.Name,AFilter) then
      begin
        if (ftNormal in AFileType) or ((Info.Attr and AttrNotNormal) > 0) then
        begin
          if ((ASubPath <> '')or(Info.Name <> '..'))and((Info.Name <> '.')) then IItems.Add(Info.Name);
        end;
      end;
    until FindNextUTF8(Info) <> 0;
  FindCloseUTF8(Info);
end;

result := IItems;
end;



function split(ASource, ASpliter: ansistring; var AOut1, AOut2: ansistring): boolean;
var
i: integer;
iSplitPos: Integer;
dd: TStringList;
begin
//
 AOut1:='';
 AOut2:='';
iSplitPos:= AnsiPos(ASpliter, ASource);
if iSplitPos > 1 then
begin
  SetLength(AOut1,iSplitPos-1);
  for i := 1 to iSplitPos-1 do
    AOut1[i]:=ASource[i];


  SetLength(AOut2,Length(ASource)-iSplitPos-(Length(ASpliter)-1));
  for i := 1 to Length(ASource)-iSplitPos-(Length(ASpliter)-1) do
     AOut2[i]:=ASource[i+iSplitPos+(Length(ASpliter)-1)];

  Result := true;
end else
begin
   AOut1:=ASource;
   AOut2:='';
   Result := true;
end;
if Length(ASource) = 0 then Result := False;
end;

function DataTimeToCookieDataTime(ADataTime:TDateTime): ansistring;
begin
  DateTimeToString(Result,'dd Mmm yyyy hh:mm:ss',ADataTime);
  Result := 'Mon, '+ Result+' GMT';
end;


function ResampleByIni(ASource: ansistring; AINIFile: ansistring; ARevers:Boolean = false): ansistring;
var
str: TStringList;
i:integer;
inam,ival:AnsiString;
begin
Result := ASource;
if not FileExists(AINIFile) then  exit;
str := TStringList.Create;
try
  str.LoadFromFile(AINIFile);
  For i := 0 to str.Count-1 do
  begin
    if not ARevers then
    begin
      if AnsiPos('|==>',str[i])>1 then
      begin
        split(str[i],'|==>',inam,ival);
        Result := AnsiReplaceText(Result,inam,ival);
        inam := AnsiReplaceText(inam,'&','&amp;');
        ival := AnsiReplaceText(ival,'&','&amp;');
        Result := AnsiReplaceText(Result,inam,ival);
      end;
    end else
    begin
      if AnsiPos('|==>',str[(str.Count-1)-i])>1 then
      begin
        split(str[(str.Count-1)-i],'|==>',inam,ival);
        Result := AnsiReplaceText(Result,ival,inam);
        inam := AnsiReplaceText(inam,'&','&amp;');
        ival := AnsiReplaceText(ival,'&','&amp;');
        Result := AnsiReplaceText(Result,ival,inam);
      end;
    end;
  end;
finally
  str.free;
end;

end;

function tplvar(AName, AValue: ansistring): TCalc_TPL_VAR;
begin
Result.name:=LowerCase(AName);
Result.value:=AValue;
end;

function LangthLimit(ASource: ansistring; ALimitSize: integer;
ALimiter: ansistring ='...'): ansistring;
begin
If Length(ASource) > ALimitSize then
begin
  SetLength(ASource, ALimitSize);
  Result:=ASource+ALimiter;

end else
  Result := ASource;
end;

function RemoveHTMLTegs(ASource: ansistring): ansistring;
var
i:integer;
itag: boolean =false;
begin
//
for i := 1 to Length(ASource) do
begin
  if ASource[i]= '<' then
  begin
    itag:= True;
    Result+=' ';
  end;


  if not itag then Result += ASource[i];

  if ASource[i]= '>' then itag:= False;

end;
end;

function HTMLToText(ASource: ansistring): ansistring;
var
i:integer;
itag: boolean =false;
begin

ASource:= RemoveHTMLTegs(ASource);


ASource:=AnsiReplaceStr(ASource,'&lt;','<');
ASource:=AnsiReplaceStr(ASource,'&gt;','>');
for i := 1 to Length(ASource) do
begin
  if ASource[i]= '&' then
  begin
    itag:= True;
    Result+=' ';
  end;
  if not itag then Result += ASource[i];
  if ASource[i]= ';' then itag:= False;
  if ASource[i]= ' ' then itag:= False;
  if ASource[i]= '<' then itag:= False;
  if ASource[i]= '>' then itag:= False;
end;
//  Result:=AnsiReplaceStr(Result,'&nbsp;',' ');


end;

function GetIndexFromString(ASource: ansistring): ansistring;
var i :integer;
begin
i:=Pos('[',ASource);
i := i + 1;
Result := '';
while (i < Length(ASource)) and (ASource[i] <> ']') do
begin
  Result := Result+ASource[i];
  inc(i);
end;
end;



function AnsiPosEx(ASubStr: ansistring; ASource: ansistring; AOffset: integer
): integer;
var
itest: ansistring;
i:integer;
begin

Result := -1;
SetLength(itest,Length(ASubStr));
while AOffset < Length(ASource)-Length(ASubStr)+1 do
begin
  for i := 1 to Length(ASubStr) do
    itest[i] := ASource[i+AOffset-1];
  if itest=ASubStr then
  begin
    Result := AOffset+1;
    Break;
    Exit;
  end;
  inc(AOffset);
end;
end;

function lowcase(ASource: ansistring): ansistring;
const
ifrom: array[0..35] of ansistring = ('Й','Ц','У','К','Е','Н','Г','Ш','Щ','З','Х','Ъ','Ф','Ы','В','А','П','Р','О','Л','Д','Ж','Э','Я','Ч','С','М','И','Т','Ь','Б','Ю','І','Ї','Ё','Є');
ito:   array[0..35] of ansistring = ('й','ц','у','к','е','н','г','ш','щ','з','х','ъ','ф','ы','в','а','п','р','о','л','д','ж','э','я','ч','с','м','и','т','ь','б','ю','і','ї','ё','є');
var
i:integer;
begin
for i := 0 to 35 do
 ASource := AnsiReplaceText(ASource,ifrom[i],ito[i]);
Result := LowerCase(ASource);
//  Result := StringsReplace(LowerCase(ASource),ifrom,iTo);
end;

function uprcase(ASource: ansistring): ansistring;
const
ito: array[0..35] of ansistring = ('Й','Ц','У','К','Е','Н','Г','Ш','Щ','З','Х','Ъ','Ф','Ы','В','А','П','Р','О','Л','Д','Ж','Э','Я','Ч','С','М','И','Т','Ь','Б','Ю','І','Ї','Ё','Є');
ifrom:   array[0..35] of ansistring = ('й','ц','у','к','е','н','г','ш','щ','з','х','ъ','ф','ы','в','а','п','р','о','л','д','ж','э','я','ч','с','м','и','т','ь','б','ю','і','ї','ё','є');
var
i:integer;
begin
for i := 0 to 35 do
 ASource := AnsiReplaceText(ASource,ifrom[i],ito[i]);
Result := UpperCase(ASource);

end;

{ TFileMemoryStream }

procedure TFileMemoryStream.SetFileName(AValue: ansistring);
begin
  if FFileName=AValue then Exit;
  if FileExists(AValue) then LoadFromFile(AValue);
  FFileName:=AValue;
  FFileAge:=FileAgeUTF8(AValue);
end;

procedure TFileMemoryStream.reload;
begin

  if FileExists(FFileName) and (FFileAge<>FileAgeUTF8(FFileName)) then
  begin
    LoadFromFile(FFileName);
    FFileAge:=FileAgeUTF8(FFileName);
  end;
end;



{ TCValueList }

function TCValueList.GetValue(const AName: ansistring): ansistring;
var
i:integer;
begin
Result := '';
for i := 0 to Length(fnames)-1 do
  if AName = fnames[i] then
  begin
    Result := fvalues[i];
    Break;
  end;
end;

procedure TCValueList.SetValue(const AName: ansistring; const AValue: ansistring);
var
i:integer;
begin
i:=0;

for i := 0 to Length(fnames)-1 do
  if AName = fnames[i] then
  begin
    fvalues[i] := AValue;
    Break;
  end;
if i = count-1 then if AName <> fnames[i] then add(AName,AValue);
if i = count then add(AName,AValue);
end;

constructor TCValueList.create;
begin
//  count := 0;
SetLength(fvalues,0);
SetLength(fnames,0);

end;

destructor TCValueList.destroy;
begin
inherited destroy;
end;

function TCValueList.NameOfValue(AValue: ansistring): ansistring;
var
i:integer;
begin
for i := 0 to count-1 do
  if AValue = fvalues[i] then
  begin
    Result := fnames[i];
    Break;
  end;
end;

function TCValueList.count: integer;
begin
Result := Length(fnames);
end;

procedure TCValueList.DeleteAllOfValue(AValue: ansistring);
var
  i, icount: integer;
begin
  icount:=0;
  for i := 0 to count-1 do
    if fvalues[i] <> AValue then
    begin
      fvalues[icount] :=fvalues[i];
      fnames[icount] :=fnames[i];
      inc(icount);
    end;
  SetLength(fvalues,icount);
  SetLength(fnames,icount);
//    count:=icount;
end;

procedure TCValueList.LoadFromFile(AFileName: ansistring);
var
//  fh:THandle;
s: ansistring;
ln, i: Integer;
str: TMemoryStream;
begin

AFileName:=AnsiReplaceStr(AFileName,'//','/');
str := TMemoryStream.Create;
try


   str.LoadFromFile(AFileName);

   str.Position:=0;

   Ffilename:=AFileName;

     ln:=str.Size;
     SetLength(s,ln);
     str.Read(s[1],Ln);


   i:=1;

   SetLength(fnames,0);
   SetLength(fvalues,0);
//     count:=0;
   add(s);
finally
   str.free;
end;


end;

procedure TCValueList.SaveToFile(AFileName: ansistring);
var
s: ansistring;
i: integer;
//  fh: THandle;
str: TMemoryStream;
begin
//
str := TMemoryStream.Create;
try

AFileName:=AnsiReplaceStr(AFileName,'//','/');
if (not Assigned(str)) or (str = nil) then exit;
s := '';
for i := 0 to count-1 do
  s := s + fnames[i]+'='+fvalues[i]+#10;

str.Size:=Length(s);
str.Position:=0;
str.Write(s[1],Length(s));

str.SaveToFile(AFileName)

finally
   str.Free
//    COOWS.cErrOut+='Ошибка сохранения: '+AFileName+#10#13;
end;
end;

procedure TCValueList.Save;
begin
SaveToFile(Ffilename);
end;

procedure TCValueList.add(AName: Ansistring; AValue: ansistring);
begin
//  inc(count);
SetLength(fnames,count+1);
SetLength(fvalues,count);
fnames[count-1] := AName;
fvalues[count-1] := AValue;
end;

procedure TCValueList.add(AStringINI: ansistring);
var
  fh:THandle;
  ln, i: Integer;
  iname, ivalue: AnsiString;
  ps:PAnsiString;
begin

  if Length(AStringINI) < 3 then exit;
  AStringINI:=AnsiReplaceStr(AStringINI,#13,#10);
  AStringINI:=AnsiReplaceStr(AStringINI,#10#10#10,#10);
  AStringINI:=AnsiReplaceStr(AStringINI,#10#10,#10);
  AStringINI:=AnsiReplaceStr(AStringINI,#10#10,#10);
  AStringINI:=AnsiReplaceStr(AStringINI,#10#10,#10);
  ln:=Length(AStringINI);
     i:=1;
     iname := '';
     ivalue:= '';
     ps:=@iname;

     if ln > 3 then if (AStringINI[1] = Char($EF)) and (AStringINI[2] = char($BB)) and (AStringINI[3] = char($BF)) then
       i := 4;

     while i <= ln do
     begin
       if (AStringINI[i] = #10) or (i = ln) then
       begin
         if i = ln then if (AStringINI[i] <> #10) and (AStringINI[i] <> '=') then ps^ += AStringINI[i];
         if iname <> '' then
         begin
//             inc(count);
//           SetLength(fnames,count);
  //         SetLength(fvalues,count);
    //       fnames[count-1] := iname;
      //     fvalues[count-1] := ivalue;
           Self[iname] := ivalue;
           iname:='';
           ivalue:='';
           ps:=@iname;
         end else
         begin
           iname:='';
           ivalue:='';
           ps:=@iname;
         end;
       end else
         if (AStringINI[i] = '=') then ps:=@ivalue
           else ps^ += AStringINI[i];
       inc(i);
     end;

end;

procedure TCValueList.Assign(Source: TPersistent);
begin
//  inherited Assign(Source);
fnames := TCValueList(Source).fnames;
fvalues := TCValueList(Source).fvalues;
Ffilename := TCValueList(Source).Ffilename;
end;



function SplitStringToLangs(ALangString: AnsiString):TNameValueArray;
var
i:integer;
ilastpos:integer;
isrc: AnsiString;
ilang: AnsiString;
iValue: AnsiString;
islang: Boolean;
begin
ilastpos:=0;

isrc:= ALangString;
islang:=false;

SetLength(Result,0);
if (Length(isrc) > 2) then
  if (isrc[1]='|')and (isrc[2]=' ') then
  begin
    islang:=true;
    i := ilastpos+3;
    while i <= Length(isrc) do
    begin
      ilang:='';
      iValue:='';
      while i <= Length(isrc) do
      begin
        if isrc[i] = ':' then break;
        ilang+=isrc[i];
        Inc(i);
      end;
      inc(i);
      while i <= Length(isrc) do
      begin
        if i < Length(isrc) then if (isrc[i] = '|') and (isrc[i+1] = ' ') then break;
        iValue+=isrc[i];
        Inc(i);
      end;
      inc(i,2);
      SetLength(Result,Length(Result)+1);
      Result[Length(Result)-1].name:=ilang;
      Result[Length(Result)-1].value:=iValue;
    end;

  end;


end;

function SetLangString(ANewValue:ansistring; ALang:ansistring; ADefLang:ansistring; ALangString:ansistring): ansistring;
var
i:integer;
seli:integer;
inva: TNameValueArray;
begin
ALang:=UpperCase(ALang);
inva := SplitStringToLangs(ALangString);
seli := -1;

if Length(inva) > 0 then
begin
  for i := 0 to Length(inva)-1 do
    if inva[i].name = ALang then
    begin
      seli:=i;
      Break;
    end;

end else
begin
  SetLength(inva,Length(inva)+1);
  inva[Length(inva)-1].name := UpperCase(ADefLang);
  inva[Length(inva)-1].value := ALangString;
  if UpperCase(ALang) = UpperCase(ADefLang) then seli:=Length(inva)-1;
end;

if seli > -1 then
begin
  inva[seli].value:=ANewValue;
end else
begin
  SetLength(inva,Length(inva)+1);
  inva[Length(inva)-1].name := ALang;
  inva[Length(inva)-1].value := ANewValue;
end;


Result := '';

for i := 0 to Length(inva)-1 do
  Result += '| '+inva[i].name+':'+inva[i].value;
//
end;


function GetLangString(ALangString:ansistring; ALang:ansistring; ADefLang:ansistring = ''): ansistring;
var
i:integer;
seli:integer;
inva: TNameValueArray;
begin
ALang:=UpperCase(ALang);
inva := SplitStringToLangs(ALangString);
seli := -1;


for i := 0 to Length(inva)-1 do
  if inva[i].name = ALang then
  begin
    seli:=i;
    Break;
  end;

if (seli = -1) and (ADefLang <> '') then
begin
  ADefLang:=UpperCase(ADefLang);
  for i := 0 to Length(inva)-1 do
    if inva[i].name = ADefLang then
    begin
      seli:=i;
      Break;
    end;
end;


if seli > -1 then Result := inva[seli].value else
begin
  Result := ALangString;
  if Length(ALangString) > 2 then
    if (ALangString[1] = '|') and (ALangString[2] = ' ') then Result := '';
end;

end;

function ArrayToAnsiString(AInput: TAnsiStringArray): ansistring;
var i: integer;
begin
   result := '';
   if Length(AInput) > 1 then
  begin
    result := 'array(';
    for i := 0 to Length(AInput)-2 do
      result += AInput[i]+', ';
    result += AInput[Length(AInput)-1];
    result += ')'
  end else
  begin
    if Length(AInput) = 1 then result := AInput[0]
      else result := '';
  end;
end;

function cMemoryStreamFromFile(AFileName: AnsiString): TFileMemoryStream;
begin
 Result :=  TFileMemoryStream.Create;
 Result.FileName := AFileName;
 Result.Position:=0;

end;

procedure tryfree(AObject: TObject);
begin
  if Assigned(AObject) then
    AObject.Free;
end;

function join(const AIn1: ansistring;const AIn2: ansistring): ansistring;
begin
  Result := AIn1+AIn2;
end;


function HTMLChars(ASource:ansistring):ansistring;
begin
  result := AnsiReplaceText(ASource,'<','&lt;');
  result := AnsiReplaceText(Result,'>','&gt;');
  result := AnsiReplaceText(Result,'"','&quot;');
  result := AnsiReplaceText(Result,'&','&amp;');
  result := AnsiReplaceText(Result,'''','&acute;');


end;

function CharFilter(ASource: ansistring; AFilter: ansistring = '1234567890qwertyuiopasdfghjklzxcvbnmQWERTYUIOPASDFGHJKLZXCVBNM_-'): ansistring;
var
  i, ilength: integer;
  icount:integer;
begin
  Result := ASource;
  icount:=0;
  ilength := Length(Result);
  for i := 1 to ilength do
    if AnsiPos(Result[i],AFilter) > 0 then
    begin
      Inc(icount);
      Result[icount] := Result[i];
    end;

  SetLength(Result,icount);
end;


end.
